/*
TASKBAR.PRG

This sample demonstrates how to use TASKBAR.DLL to start up the application
in the ICON tray.

1. To start the program normally: TASKBAR
2. To start the program in the icon tray: TASKBAR x
*/


#INCLUDE "dcdialog.CH"
#INCLUDE "dcicon.CH"
#INCLUDE "appevent.CH"
#INCLUDE "dll.CH"

#Pragma Library("Taskbar.lib")

FUNCTION Main( TaskTray )

DC_IconDefault(ICON_EXPRESS)

IF !Empty(TaskTray)
  TaskBarMenu()
ELSE
  BrowseForum()
ENDIF

RETURN nil

* -----------

PROC appsys ; RETURN

* -----------

FUNCTION TaskBarMenu()

LOCAL GetList[0], oTaskBar, oMenu, aRef[2]

oTaskBar := TaskBarIcon():New( xbeP_User + 30 ):Create()
oTaskBar:AddIcon( 1, ICON_EXPRESS , "Donnay Forum" + Chr(13) + ;
                                    'Right-Click for menu' )

DCSUBMENU oMenu PROMPT 'Taskbar Menu' PARENT oTaskBar

  DCMENUITEM 'Run Donnay Forum' PARENT oMenu ;
      ACTION {||Thread():new():start({||BrowseForum()})}

  DCMENUITEM 'Exit' PARENT oMenu ;
      ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

DCREAD GUI PARENT oTaskBar ;
   EVAL {||aRef[1] := oMenu, aRef[2] := oTaskBar} ;
   HANDLER taskBarHandler REFERENCE @aRef

oTaskBar:remAllIcons()
QUIT

RETURN nil

* -----------

STATIC FUNCTION taskBarHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, aRef )

LOCAL oMenu := aRef[1], oTaskBar := aRef[2]

IF nEvent = xbeP_User + 30
  IF mp1[2] = xbeM_RbUp
    oMenu:PopUp( oTaskBar, { mp1[3], mp1[4] } )
  ENDIF

ENDIF

RETURN DCGUI_NONE

* -------------

STATIC FUNCTION BrowseForum()

LOCAL GetList[0], GetOptions, oWebBrowser, n := 0

IF InternetGetConnectedState( @n, 0 ) == 0
  DCMSGBOX 'The Internet is NOT Available!' TIMEOUT 3
ENDIF

@ 0,0 DCHTMLVIEWER oWebBrowser SIZE 1000,800 PIXEL ;
      NAVIGATE "http://bb.donnay-software.com/donnay/index.php"

DCGETOPTIONS ;
   RESIZE ;
   RESIZEDEFAULT DCGUI_RESIZE_RESIZEONLY

DCREAD GUI FIT TITLE 'Donnay User Support Forum' ;
   SETAPPWINDOW ;
   OPTIONS GetOptions ;
   HANDLER browseHandler REFERENCE Seconds() ;
   TIMEOUT 120

RETURN nil

* ---------

STATIC FUNCTION browseHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList, nSeconds )

RETURN DCGUI_NONE

* ---------

DLLFUNCTION InternetGetConnectedState( @nFlags, nReserved ) USING STDCALL FROM WinInet.Dll

